//--*-coding:utf-8-*--

package {
    
    import com.adobe.serialization.json.JSON;
    import flash.events.Event;
    import flash.events.IOErrorEvent;
    import flash.events.ProgressEvent;
    import flash.net.FileFilter;
    import flash.net.FileReference;
    import flash.net.sendToURL;
    import flash.net.URLLoader;
    import flash.net.URLLoaderDataFormat;
    import flash.net.URLRequest;
    import flash.net.URLRequestMethod;
    import flash.net.URLVariables;
    import flash.utils.*;
    import mx.controls.Alert;
    import ym.net.HTTPPostBinary;
    import flash.geom.Point;
    
    
    public class SharedDataSender {
        
        protected var fileReferenceForUpload:FileReference = null;
        protected var loadParams:Object = null;
        
        protected var uniqueId:String = "";
        
        protected var refreshTimeoutSecond:int = 10;
        protected var refreshTimeoutPadding:int = 10;
        protected var retryWaitSeconds:int = 1;
        
        
        private var thisObj:SharedDataSender = null;
        protected var map:Map = null;
        protected var saveDataDirIndex:int = 0;
        
        protected var lastUpdateTimes:Object = getInitLastUpdateTimes();
        protected var receiver:SharedDataReceiver = newReceiverForInitialize();
        protected var refreshLoader:URLLoader = null;
        
        
        public function SharedDataSender() {
            thisObj = this;
            receiver.setSender(this);
        }
        
        public function setUniqueId(uniqueId_:String):void {
            this.uniqueId = uniqueId_;
        }
        
        public function getUniqueId():String {
            return this.uniqueId;
        }
        
        public function isSampleMode():Boolean {
            return DodontoF_Main.getInstance().isSampleMode();
        }
        
        public function setRefreshTimeout(timeout:int):void {
            this.refreshTimeoutSecond = timeout;
        }
        
        public function setMap(map_:Map):void {
            map = map_;
            receiver.setMap(map);
        }
        
        public function getMap():Map {
            return map;
        }
        
        public function getReciever():SharedDataReceiver {
            return receiver;
        }
        
        public function getRoomNumber():int {
            return saveDataDirIndex;
        }
        
        public function setSaveDataDirIndex(roomNumber:int):void {
            saveDataDirIndex = roomNumber;
        }
        
        public function checkRoomStatus(roomNumber:int, adminPassword:String, resultFunction:Function):void {
            var jsonData:Object = {
                "roomNumber" : roomNumber,
                "adminPassword" : adminPassword
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = getParamString("checkRoomStatus", [["checkRoomStatusData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function loginPassword(roomNumber:int, password:String, resultFunction:Function):void {
            Log.logging("SharedDataSender.login");
            var jsonData:Object = {
                "roomNumber" : roomNumber,
                "password" : password
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = getParamString("loginPassword", [["loginData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        protected var saveFileExtension:String = "sav";
        protected var mapSaveFileExtension:String = "msv";
        
        protected var fileReferenceForSaveDownload:FileReference;
        
        public function saveFileDownload(saveFileName:String, resultFunction:Function):void {
            
            fileReferenceForSaveDownload = new FileReference();
            fileReferenceForSaveDownload.addEventListener(Event.COMPLETE,
                                                      function(event:Event):void {
                                                          resultFunction();
                                                      });
            
            saveFileName = Config.getInstance().getUrlString(saveFileName);
            var request:URLRequest = new URLRequest(saveFileName);
            fileReferenceForSaveDownload.download(request);
        }
        
        public function save(resultFunction:Function):void {
            var params:String = this.getParamString("save", [["extension", saveFileExtension]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function saveMap(resultFunction:Function):void {
            var params:String = this.getParamString("saveMap", [["extension", mapSaveFileExtension]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function load(params:Object, resultFunction:Function):void {
            loadSelectFile(params, saveFileExtension, resultFunction);
        }
        
        public function loadMap(params:Object):void {
            loadSelectFile(params, mapSaveFileExtension);
        }
        
        protected function loadSelectFile(params:Object, extension:String, resultFunction:Function = null):void {
            loadParams = params;
            
            if( fileReferenceForUpload == null ) {
                fileReferenceForUpload  = new FileReference();
                fileReferenceForUpload.addEventListener(Event.SELECT, getFileSelectHandlerForLoad(resultFunction));
            }
            
            var filters:Array = new Array();
            filters.push(new FileFilter("セーブデータ(*." + extension + ")", "*." + extension));
            
            fileReferenceForUpload.browse(filters);
        }
        
        public function uploadImageFile(fileReferenceForImageUpload:FileReference,
                                        params:Object):void {
            sendFileUpload(fileReferenceForImageUpload, "uploadImageFile", params);
        }
        
        public function uploadImageData(params_obj:Object, resultFunction:Function, errorFunction:Function):void {
            Log.logging("SharedDataSenderBody.uploadImageData begin");
            
            var params:Array = params_obj as Array;
            var httpdata:HTTPPostBinary = new HTTPPostBinary();
            
            //(params_key:String, data:ByteArray, mimetype:String, filename:String = null)
            
            Log.logging("params.length", params.length);
            while( params.length > 0 ) {
                var param:Array = params.shift();
                var type:String = param.shift();
                
                if( type == "binary" ) {
                    Log.logging("addBinary param[0]:" + param[0] + ", param[1], param[2]:" + param[2] + ", param[3]:" + param[3]);
                    Log.logging("param[1] is null : " + (param[1] == null));
                    httpdata.addBinary(param[0], param[1], param[2], param[3]);
                } else if( type == "string" ) {
                    Log.logging("addString param[0]:" + param[0] + ", param[1]:" + param[1]);
                    httpdata.addString(param[0], param[1]);
                } else {
                    Log.loggingError("other type in uploadImageData");
                }
            }
            
            httpdata.addString("Command", "uploadImageData");
            httpdata.addString("saveDataDirIndex", "" + this.saveDataDirIndex);
            
            var request:URLRequest = new URLRequest();
            request.url = Config.getInstance().getDodontoFServerCgiUrl();
            request.contentType = httpdata.contentType;
            request.method = httpdata.method;
            request.data = httpdata.encodeData();
            
            Log.logging("loader.load() setting");
            var loader: URLLoader = new URLLoader();
            
            loader.addEventListener(IOErrorEvent.IO_ERROR, errorFunction);
            loader.addEventListener(Event.UNLOAD, errorFunction);
            loader.addEventListener(Event.COMPLETE, resultFunction);
            
            Log.logging("loader.load() begin");
            Log.logging("request.url", request.url);
            try {
                loader.load(request);
            } catch (e:Error) {
                Log.loggingException("uploadImageData", e);
                throw e;
            }
            Log.logging("loader.load() end");
            
            Log.logging("SharedDataSenderBody.uploadImageData end");
        }
        
        protected function getFileSelectHandlerForLoad(resultFunction:Function):Function {
            return function(event:Event):void {
                var fileReference:FileReference = event.currentTarget as FileReference;
                if( fileReference == null ) {
                    return;
                }
                
                thisObj.sendFileUpload(fileReference, "load", thisObj.loadParams);
                
                if( resultFunction != null ) {
                    resultFunction();
                }
            }
        }
        
        
        public function sendFileUpload(fileReferenceForLocal:FileReference,
                                        commandName:String,
                                        params:Object = null):void {
            var request:URLRequest = new URLRequest( Config.getInstance().getImageUploaderUrl() );
            
            request.method = URLRequestMethod.POST;
            var jsonData:Object = {
                "Command" : commandName,
                "saveDataDirIndex" : this.saveDataDirIndex
            };
            
            if( isSampleMode() ) {
                jsonData.isSampleMode = true;
            }
            
            if( params != null ) {
                for(var key:String in params) {
                    jsonData[key] = params[key];
                }
            }
            
            var jsonParams:String = getEncodedJsonString(jsonData);
            Log.loggingTuning("load jsonParams", jsonParams);
            
            var variables:URLVariables = new URLVariables();
            variables.__jsonDataForFileUploader__ = jsonParams;
            
            request.data = variables;
            Log.loggingTuning("fileReferenceForLocal.upload(request) calling...");
            
            fileReferenceForLocal.upload(request);
            Log.loggingTuning("fileReferenceForLocal.upload(request) called.");
        }
        
        public function checkLastUpdateTimes(type:String, jsonLastUpdateTimes:Object):Boolean {
            Log.logging("checkLastUpdateTimes begin.");
            Log.logging("checkLastUpdateTimes type", type);
            
            this.lastUpdateTimes[type] = timeValue;
            
            if( isReplayMode() ) {
                return true;
            }
            
            var timeValue:Number = jsonLastUpdateTimes[type];
            Log.logging("timeValue", timeValue);
            
            if( this.lastUpdateTimes[type] > timeValue ) {
                return false;
            }
            
            this.lastUpdateTimes[type] = timeValue;
            return true;
        }
        
        public function resurrectCharacter(resurrectCharacterId:String):void {
            var jsonData:Object = {"imgId" : resurrectCharacterId};
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = getParamString("resurrectCharacter", [["resurrectCharacterData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function sendRoundTimeData(round:int, initiative:Number, counterNames:Array):void {
            var jsonData:Object = {"round": round,
                                   "initiative": initiative,
                                   "counterNames": counterNames};
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = this.getParamString("changeRoundTime", [["roundTimeData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        
        public function startRefresh():void {
            refresh();
            startRefreshCheckTimer();
        }
        
        
        protected var refreshCheckTimer:Timer = null;
        
        protected function startRefreshCheckTimer():void {
            var timeoutMilliSecond:int = (refreshTimeoutSecond + refreshTimeoutPadding) * 1000;
            setInterval(completeRefreshCheckTimer, timeoutMilliSecond);
        }
        
        protected var preRefreshIndex:int = 0;
        
        protected function completeRefreshCheckTimer():void {
            if( preRefreshIndex != refreshIndex ) {
                preRefreshIndex = refreshIndex;
                Log.loggingTuning("refresh has NO problem.");
                return;
            }
            
            Log.loggingTuning("refresh is NOT get response. do refresh automaticaly");
            retryRefresh();
        }
        
        protected function retryRefresh():void {
            Log.loggingErrorOnStatus("サーバとの接続でエラーが発生しました。再接続します。");
            
            isRetry = true;
            
            if( refreshLoader != null ) {
                closeRefreshLoader();
            }
            
            setTimeout(function():void {
                    Log.loggingErrorOnStatus("再接続中……");
                    thisObj.refresh();
                },  (retryWaitSeconds * 1000));
        }
        
        protected var isRetry:Boolean = false;
        
        public function clearRetry():Boolean {
            if( ! isRetry ) {
                return false;
            }
            
            isRetry = false;
            return true;
        }
        
        protected var isStopRefreshOn:Boolean = false;
        
        public function stopRefresh():void {
            isStopRefreshOn = true;
        }
        
        public function isStopRefresh():Boolean {
            return isStopRefreshOn;
        }
        
        public function logout():void {
            stopRefresh();
            
            var logoutJsonData:Object = {
                "uniqueId": uniqueId};
            
            var jsonParams:String = getEncodedJsonString(logoutJsonData);
            Log.logging("jsonParams : " + jsonParams);
            
            var params:String = getParamString("logout", [["logoutData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        protected var refreshIndex:int = 0;
        
        public function refresh(obj:Object = null):void {
            if( isStopRefreshOn ) {
                return;
            }
            
            this.refreshIndex++;
            
            var userName:String = getUserName();
            
            var jsonData:Object = {
                "lastUpdateTimes": this.lastUpdateTimes,
                "refreshIndex": this.refreshIndex,
                "uniqueId": this.uniqueId,
                "userName": userName};
            
            if( DodontoF_Main.getInstance().getMentenanceModeOn() ) {
                jsonData.uniqueId = -1;
            }
            
            var refreshData:String = getEncodedJsonString(jsonData);
            Log.logging("refreshData", refreshData);
            
            var params:String = getParamString("refresh", [["refreshData", refreshData]]);
            Log.logging("refreshData params", params);
            
            var isRefresh:Boolean = true;
            sendCommandData(params, receiver.analyzeRefreshResponse, isRefresh);
        }
        
        protected function getUserName():String {
            var userName:String = "";
            
            try {
                userName = ChatWindow.getInstance().chatCharacterName.text;
            } catch (error:Error) {
            }
            
            return userName;
        }
        
        protected function isReplayMode():Boolean {
            return DodontoF_Main.getInstance().isReplayMode();
        }
        
        public function clearLastRefreshIndex(index:int):Boolean {
            if( isReplayMode() ) {
                return true;
            }
            
            if( this.refreshIndex != index ) {
                return false;
            }
            
            return true;
        }
        
        public function changeMap(mapImageUrl:String, 
                                  mapWidth:int,
                                  mapHeight:int, 
                                  gridColor:uint,
                                  mapMarks:Array):void {
            var changeMapJsonData:Object = {
                "mapType": "imageGraphic",
                "imageSource": mapImageUrl,
                "xMax": mapWidth,
                "yMax": mapHeight,
                "gridColor": gridColor,
                "mapMarks": mapMarks};
            
            Log.logging("changeMapJsonData");
            var jsonParams:String = getEncodedJsonString(changeMapJsonData);
            Log.logging("jsonParams : " + jsonParams);
            
            var params:String = getParamString("changeMap", [["mapData", jsonParams]]);
            Log.logging("var params:String : " + params);
            sendCommandData(params);
        }
        
        public function deleteImage(imageUrlList:Array,
                                    resultFunction:Function):void {
            var jsonData:Object = {
                "imageUrlList": imageUrlList
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("deleteImage", [["imageData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function addMessageCard(imageName:String, imageNameBack:String, x:int, y:int):void {
            var jsonData:Object = {
                "isText" : true,
                "imageName" : imageName,
                "imageNameBack" : imageNameBack,
                "mountName" : "messageCard",
                "isUpDown" : false,
                "canDelete" : true,
                "x" : x,
                "y" : y
            };
            var addCardData:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("addCard", [["addCardData", addCardData]]);
            sendCommandData(params);
        }
        
        public function addCardZone(ownerId:String,
                                    ownerName:String,
                                    x:int, y:int):void {
            var owner:String = "";
            drawCardInLocal(owner, x, y);
            
            var jsonData:Object = {
                "owner" : ownerId,
                "ownerName" : ownerName,
                "x" : x,
                "y" : y
            };
            var dataString:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("addCardZone", [["data", dataString]]);
            sendCommandData(params);
        }
        
        public function addCharacter(characterJsonData:Object, keyName:String = "name"):void {
            Log.logging("SharedDataSender.addCharacter() begin characterJsonData", characterJsonData);
            
            var jsonParams:String = getEncodedJsonString(characterJsonData);
            Log.logging("jsonParams", jsonParams);
            
            var params:String = getParamString("addCharacter", [["characterData", jsonParams]]);
            Log.logging("var params:String", params);
            
            Log.logging("receiver.addCharacterInOwnMap(characterJsonData) begin");
            characterJsonData[keyName] = "(作成中・・・)" + characterJsonData[keyName];
            receiver.addCharacterInOwnMap(characterJsonData);
            
            Log.logging("SharedDataSender.sendCommandData(params) begin");
            sendCommandData(params, printAddFailedCharacterName);
            Log.logging("SharedDataSender.sendCommandData(params) end");
            
            Log.logging("SharedDataSender.addCharacter() end");
        }
        
        public function printAddFailedCharacterName(event:Object):void {
            var jsonData:Object = SharedDataReceiver.getJsonDataFromResultEvent(event);
            var addFailedCharacterNames:Array = jsonData.addFailedCharacterNames;
            if( addFailedCharacterNames.length == 0 ) {
                return;
            }
            var message:String = "\"" + addFailedCharacterNames.join("\" \"") + "\"という名前のキャラクターはすでに存在するため追加に失敗しました。";
            
            //DodontoF_Main.getInstance().getChatWindow().sendSystemMessage(message, false);
            DodontoF_Main.getInstance().getChatWindow().addLocalMessage(message);
        }
        
        public function moveCharacter(movablePiece:MovablePiece, x:Number, y:Number):void {
            Log.logging("moveCharacter start.");
            var moveData:String = getEncodedJsonString( {"imgId": movablePiece.getId(), "x": x, "y": y});
            Log.logging("moveData", moveData);
            
            var params:String = this.getParamString("moveCharacter", [["characterData", moveData]]);
            this.sendCommandData(params);
        }
        
        public function removeCharacter(piece:Piece):void {
            removeCharacters( [piece] );
        }
        
        public function removeInvalidCharacter(characterId:String):void {
            removeCharacterByRemoveInfos( [getRemoveInfo(characterId, true)] );
        }
        
        static public function getRemoveInfo(characterId:String, isGotoGraveyard:Boolean):Object {
            var removeInfo:Object = {"imgId" : characterId,
                                     "isGotoGraveyard" : isGotoGraveyard};
            return removeInfo;
        }
        
        public function removeCharacters(pieces:Array):void {
            var infos:Array = [];
            
            for(var i:int = 0 ; i < pieces.length ; i++) {
                var piece:Piece = pieces[i];
                infos.push( getRemoveInfo(piece.getId(), piece.isGotoGraveyard()) );
            }
            
            removeCharacterByRemoveInfos( infos );
        }
        
        protected function removeCharacterByRemoveInfos(removeInfos:Array):void {
            var jsonParams:String = getEncodedJsonString( removeInfos );
            var params:String = this.getParamString("removeCharacter", [["removeCharacterData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function changeCharacter(characterJsonData:Object):void {
            Log.logging("characterJsonData", characterJsonData);
            var jsonParams:String = getEncodedJsonString(characterJsonData);
            Log.logging("jsonParams : " + jsonParams);
            
            var params:String = getParamString("changeCharacterData", [["characterData", jsonParams]]);
            Log.logging("var params:String : " + params);
            sendCommandData(params);
        }
        
        public function sendDiceBotChatMessage(chatSendData:ChatSendData,
                                               randomSeed:int, gameType:String,
                                               callBack:Function):void {
            var request:URLRequest = new URLRequest();
            request.url = Config.getInstance().getDiceBotCgiUrl();
            request.method = URLRequestMethod.POST;
            
            var variables:URLVariables = new URLVariables();
            variables.channel = chatSendData.getChannel();
            variables.name = chatSendData.getName();
            variables.state = chatSendData.getState();
            variables.sendto = chatSendData.getSendto();
            variables.message = chatSendData.getMessage();
            variables.randomSeed = randomSeed;
            variables.gameType = gameType;
            
            request.data = variables;
            
            var loader:URLLoader = new URLLoader();
            loader.addEventListener(Event.COMPLETE, callBack);
            loader.load(request);
        }
        
        public function sendChatMessage(jsonData:Object):void {
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("sendChatMessage", [["chatMessageData", jsonParams]]);
            
            this.sendCommandData(params);
        }
        
        
        public function sendChatMessageMany(chatCharacterName:String, message:String, color:String):void {
            var jsonData:Object = {
                "senderName": chatCharacterName,
                "message" : message,
                "color" : color
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("sendChatMessageMany", [["chatMessageData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        
        protected function sendCommandData(paramsString:String,
                                        callBack:Function = null,
                                        isRefresh:Boolean = false):void {
            Log.loggingTuning("==>Begin sendCommandData");
            Log.logging("sendCommandData paramsString : ", paramsString);
            
            try {
                sendCommandDataCatched(paramsString,
                                       callBack,
                                       isRefresh);
            } catch( e:Error ) {
                Log.loggingException("SharedDataSender.sendCommandData()", e);
            }
            Log.loggingTuning("==>End sendCommandData");
        }
        
        public function createPlayRoom(playRoomName:String,
                                       playRoomPassword:String,
                                       playRoomIndex:int,
                                       resultFunction:Function):void {
            var jsonData:Object = {
                "playRoomName": playRoomName,
                "playRoomPassword": playRoomPassword,
                "playRoomIndex": playRoomIndex
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("createPlayRoom", [["createPlayRoomData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function changePlayRoom(playRoomName:String,
                                       playRoomPassword:String,
                                       playRoomIndex:int,
                                       resultFunction:Function):void {
            var jsonData:Object = {
                "playRoomName": playRoomName,
                "playRoomPassword": playRoomPassword
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("changePlayRoom", [["changePlayRoomData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function requestImageList(resultFunction:Function):void {
            var jsonData:Object = {
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("getImageList", [["imageData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function requestImageTagInfosAndImageList(resultFunction:Function):void {
            var params:String = this.getParamString("getImageTagsAndImageList", []);
            this.sendCommandData(params, resultFunction);
        }
        
        public function requestGraveyard(resultFunction:Function):void {
            var params:String = this.getParamString("getGraveyardCharacterData", []);
            this.sendCommandData(params, resultFunction);
        }
        
        public function requestLoginInfo(resultFunction:Function):void {
            var params:String = this.getParamString("getLoginInfo", [[]]);
            this.sendCommandData(params, resultFunction);
        }

        public function uploadImageUrl(imageUrl:String, tagInfo:Object, resultFunction:Function):void {
            var jsonData:Object = {"imageUrl": imageUrl,
                                   "tagInfo" : tagInfo };
            
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = this.getParamString("uploadImageUrl", [["imageData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }


        protected function newReceiverForInitialize():SharedDataReceiver {
            return new SharedDataReceiver();
        }
        
        protected var mentenanceCommands:Array = ["loginPassword", "getLoginInfo", "checkRoomStatus", "refresh"];
        
        protected function isIgnoreCommand(commandName:String):Boolean {
            if( ! DodontoF_Main.getInstance().getMentenanceModeOn() ) {
                return false;
            }
            
            for(var i:int = 0 ; i < mentenanceCommands.length ; i++) {
                var mentenanceCommand:String = mentenanceCommands[i] as String;
                if( commandName == mentenanceCommand ) {
                    return false;
                }
            }
            
            return true;
        }
        
        protected function getParamString(commandName:String, params:Array):String {
            Log.logging("getParamString begin");
            
            if( isIgnoreCommand(commandName) ) {
                return null;
            }
            
            params.push(["Command", commandName]);
            params.push(["saveDataDirIndex", this.saveDataDirIndex]);
            
            if( isSampleMode() ) {
                params.push(["isSampleMode", true]);
            }
            
            Log.logging("paramString creating...");
            var paramString:String = new String();
            
            Log.logging("params analyzing ");
            for(var i:int = 0 ; i < params.length ; i++) {
                var param:Array = params[i] as Array;
                
                if( i != 0 ) {
                    paramString += "&";
                }
                
                paramString += param[0];
                paramString += "=";
                paramString += param[1];
            }
            
            Log.logging("getParamString paramString: " + paramString);
            
            return paramString;
        }
        
        public function startSessionRecording():void {
            var tmpTimes:Object = getInitLastUpdateTimes();
            tmpTimes.chatMessageDataLog = lastUpdateTimes.chatMessageDataLog;
            lastUpdateTimes = tmpTimes;
            receiver.startHistory();
        }
        
        public function clearLastUpdateTimes():void {
            lastUpdateTimes = getInitLastUpdateTimes();
        }
        
        protected function getInitLastUpdateTimes():Object {
            var lastUpdateTimes:Object = {
                'map': 0,
                'characters': 0,
                'chatMessageDataLog': 0,
                'time': 0,
                'effects': 0
            };
            return lastUpdateTimes;
        }
        
        public function resetLastUpdateTimeOfInitiativeTimer():void {
            resetLastUpdateTime('time');
        }
        
        protected function resetLastUpdateTime(type:String):void {
            lastUpdateTimes[type] = 0;
        }
        
        protected function closeRefreshLoader():void {
            closeLoader(refreshLoader);
        }
        
        protected function closeLoader(loader:URLLoader):void {
            try {
                loader.close();
            } catch( e:Error ) {
                //refreshLoaderは通信状態が不安定な場合には無理やり閉じる必要がある。
                //つまり、通常の運用でも発生する場合のある例外。
                //このため通常のエラー処理とは異なりエラーログにログ出力していない。
                Log.loggingExceptionDebug("SharedDataSender.closeLoader()", e);
            }
        }
        
        protected function getUrlRequestForSendCommandData(paramsString:String):URLRequest {
            Log.logging("var request:URLRequest = new URLRequest();");
            var request:URLRequest = new URLRequest();
            request.url = Config.getInstance().getDodontoFServerCgiUrl();
            request.method = URLRequestMethod.POST;
            
            Log.logging("var variables:URLVariables = new URLVariables(paramsString);");
            var variables:URLVariables = new URLVariables(paramsString);
            request.data = variables;
            
            return request;
        }
        
        protected function getUrlLoaderForSendCommand(callBack:Function):URLLoader {
            
            Log.logging("loader begin");
            var loader:URLLoader = new URLLoader();
            
            var wrappedCallBack:Function = function(event:Event):void {
                if( callBack != null ) {
                    callBack.call(thisObj, event);
                }
                var oldLoader:URLLoader = URLLoader(event.target);
                if( oldLoader != refreshLoader ) {
                    closeLoader(oldLoader);
                }
            }
            loader.addEventListener(Event.COMPLETE, wrappedCallBack);
            
            var wrappedCallBackForError:Function = function(event:Event):void {
                var oldLoader:URLLoader = URLLoader(event.target);
                if( oldLoader != refreshLoader ) {
                    closeLoader(oldLoader);
                }
            }
            
            loader.addEventListener(IOErrorEvent.IO_ERROR, wrappedCallBackForError);
            loader.addEventListener(Event.UNLOAD, wrappedCallBackForError);
            
            return loader;
        }
        
        protected function sendCommandDataCatched(paramsString:String,
                                                callBack:Function,
                                                isRefresh:Boolean = false):void {
            if( paramsString == null ) {
                return;
            }
            
            var request:URLRequest = getUrlRequestForSendCommandData(paramsString);
            
            if( callBack == null ) {
                Log.loggingTuning("sendToURL begin");
                sendToURL(request);
                Log.loggingTuning("sendToURL end");
                return;
            }
            
            var loader:URLLoader = null;
            
            if( isRefresh ) {
                if( refreshLoader == null ) {
                    refreshLoader = getUrlLoaderForSendCommand(callBack);
                }
                closeRefreshLoader();
                
                loader = refreshLoader;
            } else {
                loader = getUrlLoaderForSendCommand(callBack);
            }
            
            loader.load(request);
            Log.logging("loader end");
        }
        
        public static function getJsonString(jsonData:Object):String {
            return Utils.getJsonString(jsonData);
        }
        
        public static function getEncodedJsonString(jsonData:Object):String {
            return Utils.getEncodedJsonString(jsonData);
        }
        
        public function getExistPiecesCount():int {
            return map.getExistPiecesCount();
        }
        
        public function removePlayRoom(roomNumber:int, resultFunction:Function, ignoreLoginUser:Boolean):void {
            var jsonData:Object = {
                "roomNumber": roomNumber,
                "ignoreLoginUser": ignoreLoginUser
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = this.getParamString("removePlayRoom", [["removePlayRoomData", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function addEffect(params_:Object):void {
            var jsonParams:String = getEncodedJsonString( params_ );
            var params:String = this.getParamString("addEffect", [["effectData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function changeEffect(params_:Object):void {
            var jsonParams:String = getEncodedJsonString( params_ );
            var params:String = this.getParamString("changeEffect", [["effectData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function removeEffect(effectId:String):void {
            var jsonData:Object = {
                "effectId": effectId
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("removeEffect", [["effectData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function changeImageTags(params_:Object):void {
            var jsonParams:String = getEncodedJsonString( params_ );
            var params:String = this.getParamString("changeImageTags", [["tagsData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function initCards(cardTypes:Array):void {
            var jsonData:Object = {
                "cardTypeInfos": cardTypes
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("initCards", [["initCardsData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function clearCards():void {
            var jsonData:Object = {
                "types": [Card.getTypeStatic(), CardMount.getTypeStatic()]
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("clearCharacterByType", [["clearData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        
        private function drawCardInLocal( owner:String,
                                          x:int,
                                          y:int):void {
            
            var text:String = "<p align='center'><font size=\"72\">LOADING...</font><p>";
            var cardJsonData:Object = Card.getJsonData(text, text, x, y);
            
            cardJsonData = getCloneCardJsonData(cardJsonData, x, y);
            cardJsonData.owner = owner;
            receiver.addCharacterInOwnMap(cardJsonData);
        }
        
        public function drawCard( isOpen:Boolean,
                                  owner:String,
                                  ownerName:String,
                                  mountName:String,
                                  x:int,
                                  y:int,
                                  id_:String ):void {
            
            drawCardInLocal(owner, x, y);
            
            var jsonData:Object = {
                "isOpen": isOpen,
                "mountName": mountName,
                "owner": owner,
                "ownerName":ownerName,
                "x": x,
                "y": y,
                "imgId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("drawCard", [["drawCardData", jsonParams]]);
            
            var resultFunction:Function = function(event:Event):void {
                var jsonData:Object = SharedDataReceiver.getJsonDataFromResultEvent(event);
                var result:String = jsonData.result;
                if( result != "OK" ) {
                    receiver.removeCharacterOnlyOwnMap(event);
                }
            };
            
            this.sendCommandData(params, resultFunction);
        }
        
        private function getCloneCardJsonData(cardJsonData:Object, x:int, y:int):Object {
            
            cardJsonData = Utils.clone(cardJsonData);
            cardJsonData.imgId = MovablePiece.getDefaultId();
            cardJsonData.x = x;
            cardJsonData.y = y;
            cardJsonData.draggable = false;
            cardJsonData.ownerName = "(作成中・・・)";
            
            return cardJsonData;
        }
        
        public function drawTargetCard( cardJsonData:Object,
                                        ownerId:String,
                                        ownerName:String,
                                        mountId:String,
                                        mountName:String,
                                        targetCardId:String,
                                        x:int,
                                        y:int,
                                        resultFunction:Function):void {
            
            cardJsonData = getCloneCardJsonData(cardJsonData, x, y);
            receiver.addCharacterInOwnMap(cardJsonData);
            
            var jsonData:Object = {
                "owner" : ownerId,
                "ownerName" : ownerName,
                "mountId" : mountId,
                "mountName" : mountName,
                "targetCardId" : targetCardId,
                "x": x,
                "y": y
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("drawTargetCard", [["data", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
        
        public function returnCard( mountName:String,
                                    x:int,
                                    y:int,
                                    id_:String ):void {
            var jsonData:Object = {
                "mountName": mountName,
                "x": x,
                "y": y,
                "imgId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("returnCard", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        
        public function shuffleCards( mountName:String, id_:String, isShuffle:Boolean ):void {
            var jsonData:Object = {
                "mountName": mountName,
                "imgId": id_,
                "isShuffle": isShuffle
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("shuffleCards", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function dumpTrushCard( targetCardId:String, mountName:String, id_:String ):void {
            var jsonData:Object = {
                "dumpedCardId": targetCardId,
                "mountName": mountName,
                "trushMountId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("dumpTrushCards", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function getMountCardInfos(mountName:String, resultFunction:Function):void {
            var cardName:String = InitCardWindow.getCardName(mountName);
            DodontoF_Main.getInstance().getChatWindow().sendSystemMessage("が「" + cardName + "」の山札を参照しています。");
            
            var jsonData:Object = {
                "mountName": mountName
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("getMountCardInfos", [["data", jsonParams]]);
            this.sendCommandData(params, resultFunction);
        }
    }
}
